version: '3'
services:
  opensearch-node1:
    image: opensearchproject/opensearch:1.2.4
    container_name: opensearch-node1
    environment:
      - cluster.name=opensearch-cluster
      - node.name=opensearch-node1
      - bootstrap.memory_lock=true # along with the memlock settings below, disables swapping
      - "OPENSEARCH_JAVA_OPTS=-Xms512m -Xmx512m" # minimum and maximum Java heap size, recommend setting both to 50% of system RAM
      - "DISABLE_INSTALL_DEMO_CONFIG=true" # disables execution of install_demo_configuration.sh bundled with security plugin, which installs demo certificates and security configurations to OpenSearch
      - "discovery.type=single-node" # disables bootstrap checks that are enabled when network.host is set to a non-loopback address
    ulimits:
      memlock:
        soft: -1
        hard: -1
      nofile:
        soft: 65536 # maximum number of open files for the OpenSearch user, set to at least 65536 on modern systems
        hard: 65536
    volumes:
      - opensearch-data1:/usr/share/opensearch/data
      - ./opensearch-conf/opensearch.yml:/usr/share/opensearch/config/opensearch.yml
      - ./opensearch-conf/node1.pem:/usr/share/opensearch/config/node1.pem
      - ./opensearch-conf/node1-key.pem:/usr/share/opensearch/config/node1-key.pem
      - ./opensearch-conf/admin.pem:/usr/share/opensearch/config/admin.pem
      - ./opensearch-conf/admin-key.pem:/usr/share/opensearch/config/admin-key.pem
      - ./opensearch-conf/root-ca.pem:/usr/share/opensearch/config/root-ca.pem
      - ./opensearch-conf/security-conf/config.yml:/usr/share/opensearch/plugins/opensearch-security/securityconfig/config.yml
      - ./opensearch-conf/security-conf/roles_mapping.yml:/usr/share/opensearch/plugins/opensearch-security/securityconfig/roles_mapping.yml
      - ./opensearch-conf/security-conf/internal_users.yml:/usr/share/opensearch/plugins/opensearch-security/securityconfig/internal_users.yml
      - ./opensearch-conf/log4j2.properties:/usr/share/opensearch/config/log4j2.properties
    ports:
      - 9200:9200
      - 9600:9600 # required for Performance Analyzer
    networks:
      - opensearch-net

  opensearch-dashboards:
    image: opensearchproject/opensearch-dashboards:1.2.0
    container_name: opensearch-dashboards
    volumes:
      - ./dashboard-conf/opensearch_dashboards.yml:/usr/share/opensearch-dashboards/config/opensearch_dashboards.yml
      - ./dashboard-conf/opensearch.example.org.cert:/usr/share/opensearch-dashboards/config/opensearch.example.org.cert
      - ./dashboard-conf/opensearch.example.org.key:/usr/share/opensearch-dashboards/config/opensearch.example.org.key
    ports:
      - 5601:5601
    expose:
      - "5601"
    environment:
      - 'OPENSEARCH_HOSTS=["https://opensearch-node1:9200"]'
      - 'OPENSEARCH_SSL_VERIFICATIONMODE="none"'
    networks:
      - opensearch-net

volumes:
  opensearch-data1:

networks:
  opensearch-net:
